-- The top module of Deep Learning on FPGA
-- by Toshio Iwata at digitalfilter.com 2019/02/13

library ieee ;
use ieee.std_logic_1164.all ;
use ieee.std_logic_arith.all ;
use ieee.std_logic_signed.all;

-------------------------------------------------------------------------------
-- Entity
-------------------------------------------------------------------------------
entity ROM_W1 is
port(
          DATA_00 : Out std_logic_vector(8 downto 0);
          DATA_01 : Out std_logic_vector(8 downto 0);
          DATA_02 : Out std_logic_vector(8 downto 0);
          DATA_03 : Out std_logic_vector(8 downto 0);
          DATA_04 : Out std_logic_vector(8 downto 0);
          DATA_05 : Out std_logic_vector(8 downto 0);
          DATA_06 : Out std_logic_vector(8 downto 0);
          DATA_07 : Out std_logic_vector(8 downto 0);
          DATA_08 : Out std_logic_vector(8 downto 0);
          DATA_09 : Out std_logic_vector(8 downto 0);
          DATA_10 : Out std_logic_vector(8 downto 0);
          DATA_11 : Out std_logic_vector(8 downto 0);
          DATA_12 : Out std_logic_vector(8 downto 0);
          DATA_13 : Out std_logic_vector(8 downto 0);
          DATA_14 : Out std_logic_vector(8 downto 0);
          DATA_15 : Out std_logic_vector(8 downto 0);
          DATA_16 : Out std_logic_vector(8 downto 0);
          DATA_17 : Out std_logic_vector(8 downto 0);
          DATA_18 : Out std_logic_vector(8 downto 0);
          DATA_19 : Out std_logic_vector(8 downto 0);
          DATA_20 : Out std_logic_vector(8 downto 0);
          DATA_21 : Out std_logic_vector(8 downto 0);
          DATA_22 : Out std_logic_vector(8 downto 0);
          DATA_23 : Out std_logic_vector(8 downto 0);
          DATA_24 : Out std_logic_vector(8 downto 0);
          DATA_25 : Out std_logic_vector(8 downto 0);
          DATA_26 : Out std_logic_vector(8 downto 0);
          DATA_27 : Out std_logic_vector(8 downto 0);
          DATA_28 : Out std_logic_vector(8 downto 0);
          DATA_29 : Out std_logic_vector(8 downto 0);
          DATA_30 : Out std_logic_vector(8 downto 0);
          DATA_31 : Out std_logic_vector(8 downto 0);
          DATA_32 : Out std_logic_vector(8 downto 0);
          DATA_33 : Out std_logic_vector(8 downto 0);
          DATA_34 : Out std_logic_vector(8 downto 0);
          DATA_35 : Out std_logic_vector(8 downto 0);
          DATA_36 : Out std_logic_vector(8 downto 0);
          DATA_37 : Out std_logic_vector(8 downto 0);
          DATA_38 : Out std_logic_vector(8 downto 0);
          DATA_39 : Out std_logic_vector(8 downto 0);
          DATA_40 : Out std_logic_vector(8 downto 0);
          DATA_41 : Out std_logic_vector(8 downto 0);
          DATA_42 : Out std_logic_vector(8 downto 0);
          DATA_43 : Out std_logic_vector(8 downto 0);
          DATA_44 : Out std_logic_vector(8 downto 0);
          DATA_45 : Out std_logic_vector(8 downto 0);
          DATA_46 : Out std_logic_vector(8 downto 0);
          DATA_47 : Out std_logic_vector(8 downto 0);
          DATA_48 : Out std_logic_vector(8 downto 0);
          DATA_49 : Out std_logic_vector(8 downto 0);
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(9 downto 0) );
end ROM_W1;

-------------------------------------------------------------------------------
-- Architecture
-------------------------------------------------------------------------------
architecture RTL of ROM_W1 is

-----------------------------------
component ROM_W1_00
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_01
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_02
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_03
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_04
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_05
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_06
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_07
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_08
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_09
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

-----------------------------------
component ROM_W1_10
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_11
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_12
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_13
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_14
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_15
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_16
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_17
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_18
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_19
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

-----------------------------------
component ROM_W1_20
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_21
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_22
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_23
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_24
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_25
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_26
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_27
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_28
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_29
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

-----------------------------------
component ROM_W1_30
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_31
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_32
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_33
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_34
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_35
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_36
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_37
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_38
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_39
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

-----------------------------------
component ROM_W1_40
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_41
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_42
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_43
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_44
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_45
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_46
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_47
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_48
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

component ROM_W1_49
   Port (
          CLK : In std_logic;
          CS_N : In std_logic;
          ADDR : In std_logic_vector(10-1 downto 0);
          DATA : Out std_logic_vector(9-1 downto 0) );
end component;

-------------------------------------------------------------------------------
-- Signal
-------------------------------------------------------------------------------

-- signal tmp : std_logic_vector(8 downto 0);

begin
---------------------------------------------------------
ROM_W1_00_inst : ROM_W1_00 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_00 );

ROM_W1_01_inst : ROM_W1_01 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_01 );

ROM_W1_02_inst : ROM_W1_02 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_02 );

ROM_W1_03_inst : ROM_W1_03 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_03 );

ROM_W1_04_inst : ROM_W1_04 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_04 );

ROM_W1_05_inst : ROM_W1_05 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_05 );

ROM_W1_06_inst : ROM_W1_06 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_06 );

ROM_W1_07_inst : ROM_W1_07 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_07 );

ROM_W1_08_inst : ROM_W1_08 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_08 );

ROM_W1_09_inst : ROM_W1_09 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_09 );

---------------------------------------------------------
ROM_W1_10_inst : ROM_W1_10 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_10 );

ROM_W1_11_inst : ROM_W1_11 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_11 );

ROM_W1_12_inst : ROM_W1_12 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_12 );

ROM_W1_13_inst : ROM_W1_13 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_13 );

ROM_W1_14_inst : ROM_W1_14 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_14 );

ROM_W1_15_inst : ROM_W1_15 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_15 );

ROM_W1_16_inst : ROM_W1_16 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_16 );

ROM_W1_17_inst : ROM_W1_17 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_17 );

ROM_W1_18_inst : ROM_W1_18 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_18 );

ROM_W1_19_inst : ROM_W1_19 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_19 );

---------------------------------------------------------
ROM_W1_20_inst : ROM_W1_20 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_20 );

ROM_W1_21_inst : ROM_W1_21 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_21 );

ROM_W1_22_inst : ROM_W1_22 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_22 );

ROM_W1_23_inst : ROM_W1_23 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_23 );

ROM_W1_24_inst : ROM_W1_24 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_24 );

ROM_W1_25_inst : ROM_W1_25 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_25 );

ROM_W1_26_inst : ROM_W1_26 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_26 );

ROM_W1_27_inst : ROM_W1_27 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_27 );

ROM_W1_28_inst : ROM_W1_28 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_28 );

ROM_W1_29_inst : ROM_W1_29 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_29 );

---------------------------------------------------------
ROM_W1_30_inst : ROM_W1_30 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_30 );

ROM_W1_31_inst : ROM_W1_31 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_31 );

ROM_W1_32_inst : ROM_W1_32 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_32 );

ROM_W1_33_inst : ROM_W1_33 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_33 );

ROM_W1_34_inst : ROM_W1_34 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_34 );

ROM_W1_35_inst : ROM_W1_35 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_35 );

ROM_W1_36_inst : ROM_W1_36 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_36 );

ROM_W1_37_inst : ROM_W1_37 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_37 );

ROM_W1_38_inst : ROM_W1_38 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_38 );

ROM_W1_39_inst : ROM_W1_39 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_39 );

---------------------------------------------------------
ROM_W1_40_inst : ROM_W1_40 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_40 );

ROM_W1_41_inst : ROM_W1_41 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_41 );

ROM_W1_42_inst : ROM_W1_42 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_42 );

ROM_W1_43_inst : ROM_W1_43 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_43 );

ROM_W1_44_inst : ROM_W1_44 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_44 );

ROM_W1_45_inst : ROM_W1_45 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_45 );

ROM_W1_46_inst : ROM_W1_46 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_46 );

ROM_W1_47_inst : ROM_W1_47 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_47 );

ROM_W1_48_inst : ROM_W1_48 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_48 );

ROM_W1_49_inst : ROM_W1_49 port map (
  CLK => CLK,  
  CS_N => '0', 
  ADDR => ADDR(9 downto 0), 
  DATA => DATA_49 );

end RTL;

